;/*%.fh================================================================
;
;	Filename:	XC_IO.ASM			007 03-Mar-95
;
;	Author:		Karl-Heinz Weiss
;			(khweis@mvmpc9.ciw.uni-karlsruhe.de)
;
;	Master Copy:	c:\usr\ian
;
;	Module List:	RCVCMD, RCVMSG, RCVCHR, SENDCMD
;
;	References:	$
;
;	Build:		$
;
;	Description:	$
;
;	Revision History:
;	000	16-Feb-95  IH	Modified version of X_TCP.ASM for XC_NEWS.C
;
;*%.end==============================================================*/

.8086
.model medium,c
.data
;timeout		dw	180		; about 10 secs
	extrn	ttimeout:word
ticksav		dw	0
.code
eol     equ     0ah
eom     dw      0

start:
;RCVCHR% CDECL()
;Lesen eines Zeichens. Rckgabewert ist der
;Charactercode. Der Wert ist -1 wenn kein
;Zeichen gelesen werden konnte, und kleiner -1
;wenn ein Timeoutfehler registriert wurde
	public	RCVCHR
RCVCHR  proc
	mov     ah,3       ;Get_Status
	int     14h
	and     ax,8100h   ;Signbit indicates Timeout
	js      rcvchr2
	mov     ax,-1
	jz      rcvchr2
	mov     ah,2
	int     14h
	and     ah,80
rcvchr2:
	ret
RCVCHR  endp

;----------------------------------------------------------------
;
;	R C V C H R T  - Receive character with timeout
;
	public	RCVCHRT
RCVCHRT	proc
	push	cx
	mov	cx,ttimeout	; timeout count loop
rcvt1:	mov	ah,3		;Get_Status
	int	14h
	and	ax,8100h	;Signbit indicates Timeout
	js	rcvt2
	jnz	rcvt3		;t jump if character available
	push	ds		;t
	xor	ax,ax		;t
	mov	ds,ax		;t
	mov	ax,ds:[46Ch]	;t ls word of tick
	pop	ds		;t
	cmp	ax,ticksav	;t has it changed?
	jz	rcvt1		;t loop if not
	mov	ticksav,ax	;t else save the new tick
	loop	rcvt1		;t and count down tick changes
	pop	cx		;t
	mov	ax,8100h	;t label as bad
	or	ax,ax		;t set flags
	ret			;t
rcvt3:	mov	ah,2
	int	14h
	and	ah,80
rcvt2:	pop	cx
	ret
RCVCHRT	endp

;----------------------------------------------------------------
;
;	S N D C H R T  - Send character with timeout
;
	public	SNDCHRT
SNDCHRT	proc
	push	cx
	mov	cx,ttimeout	; timeout count loop
sndt1:	mov	ah,3		;Get_Status
	int	14h
	and	ah,0B0h		;Signbit indicates Timeout
	js	sndt2
	jnz	sndt3		;t jump if can send
	push	ds		;t
	xor	ax,ax		;t
	mov	ds,ax		;t
	mov	ax,ds:[46Ch]	;t ls word of tick
	pop	ds		;t
	cmp	ax,ticksav	;t has it changed?
	jz	sndt1		;t loop if not
	mov	ticksav,ax	;t else save the new tick
	loop	sndt1		;t and count down tick changes
	pop	cx		;t
	mov	ax,8100h	;t label as bad
	or	ax,ax		;t set flags
	ret			;t
sndt3:	mov	ah,1		; send character
	int	14h
	and	ah,80
sndt2:	pop	cx
	ret
SNDCHRT	endp

;RCVMSG% CDECL(ofs%, seg%, len%)
;Lesen einer Message. Alle Ctrl-Character ausser 0ah werden
;entfernt. Ende der Message ist '0ah,'.',0ah.
;Rckgabewert ist dann die negative Zeilenlaenge.
;Der Wert ist < -16384 wenn ein Timeoutfehler aufgetreten ist
	public	RCVMSG
RCVMSG proc uses es di, off:word, sgm:word, len:word
;	mov     bx,off
;	mov     di,[bx]
;	mov     bx,sgm
;	mov     es,[bx]
;	mov     bx,len
;	mov     cx,[bx]

	mov	di,off		; Changed for C rather than QB
	mov	es,sgm
	mov	cx,len

rcvmsg1:
;	mov     ah,3
;	int     14h
;	and     ax,8100h
;	js      rcvmsg6        ;Error
;	jz      rcvmsg1		; loop if no character
;	mov     ah,2
;	int     14h
;	and     ah,ah
;	js      rcvmsg6        ;Error

	call	RCVCHRT		; get the character, or timeout
	jnz	rcvmsg6		; jump if an error

	cmp     al,0dh         ;supress 0dh
	jz      rcvmsg1
	cmp     al,0ah         ;test lfd
	jnz     rcvmsg2
	cmp     cs:[eom],0a2eh   ;eom?
	jnz     rcvmsg3
	dec     cx
	mov     byte ptr es:[di],al
	mov     ax,cx
;	sub     ax,[bx]     ;count <1 markiert Ende
	sub     ax,len      ;count <1 markiert Ende
	jmp     rcvmsg6
rcvmsg2: cmp    cs:[eom],0a2eh
	 jnz    rcvmsg3
	 cmp    al,"."
rcvmsg3: mov    ah,byte ptr cs:[eom]
	 mov    cs:[eom],ax
	 jz      rcvmsg1       ;suppress 0a..
	 mov     byte ptr es:[di],al
	 inc     di
	 loop    rcvmsg1
;	 mov     ax,[bx]
	 mov     ax,len
	 sub     ax,cx
rcvmsg6:
	 ret
RCVMSG	endp

;RCVCMD% CDECL(ofs%, seg%, len%)
;Lesen einer Zeile. Zeilenabschlusszeichen werden entfernt.
;Rckgabewert ist die Zeilenlaenge. Der Wert ist negativ
;wenn ein Timeoutfehler aufgetreten ist
	public	RCVCMD
RCVCMD  proc uses es di, off:word, sgm:word, len:word
;	mov     bx,off
;	mov     di,[bx]
;	mov     bx,sgm
;	mov     es,[bx]
;	mov     bx,len
;	mov     cx,[bx]

	mov	di,off
	mov	es,sgm
	mov	cx,len
rcvcmd1:
;	mov     ah,3       ;Get_Status
;	int     14h
;	and     ah,81h     ;Signbit indicates Timeout
;	js      tcpin5
;	jz      rcvcmd1    ;zero indicates no data available
;	mov     ah,2       ;Get_Character
;	int     14h
;	and     ah,ah      ;Test Status
;	js      tcpin5     ;Signbit indicates Error

	call	RCVCHRT		; get the character, or timeout
	jnz	tcpin5		; jump if an error

	cmp     al,eol     ;test end_of_line
	jz      tcpin4
	cmp     al,0dh     ;remove cr
	jz      rcvcmd1
	mov     byte ptr es:[di],al
	inc     di
	loop    rcvcmd1
tcpin4:
;	mov     ax,[bx]
	mov     ax,len
	sub     ax,cx
tcpin5:
	ret
RCVCMD endp


;SENDCMD% CDECL(ofs%, sgm%, len%)
;Ausgabe eines Textes. Zeilenabschluss wird hinzugefgt.
;Rckgabewert ist negati ;wenn ein Timeoutfehler aufgetreten ist
	public	SENDCMD
SENDCMD proc uses es di, off:word, sgm:word, len:word
;	mov     bx,off
;	mov     di,[bx]
;	mov     bx,sgm
;	mov     es,[bx]
;	mov     bx,len
;	mov     cx,[bx]

	mov	di,off
	mov	es,sgm
	mov	cx,len

	mov	cs:[eom],0a0ah	;Set to handle an empty '.' message

	and     cx,cx
	mov     ax,cx
	jz      sendcmd2

sendcmd1:
	push	cx
	mov	cx,ttimeout	; timeout count loop
sndstat:
	mov     ah,3		;Get_Status
	int     14h
	and     ah,0b0h
	jz      sndwait		;zero indicates 'plz_wait'
	pop	cx
	js      sendcmd2	;sign indicates timeout
	jmp	short sendok	; jump if can send
sndwait:
	push	ds		;t
	xor	ax,ax		;t
	mov	ds,ax		;t
	mov	ax,ds:[46Ch]	;t ls word of tick
	pop	ds		;t
	cmp	ax,ticksav	;t has it changed?
	jz	sndstat		;t loop if not
	mov	ticksav,ax	;t else save the new tick
	loop	sndstat		;t and count down tick changes
	pop	cx		;t
	jmp	short sendcmd2	;t bail out

sendok:	mov     al,byte ptr es:[di]
	mov     ah,1         ;Send_Character
	int     14h
	and     ah,ah
	js      sendcmd2
	inc     di
	loop    sendcmd1
	mov     ax,0
	jmp     sendcmd3
sendcmd2:
	 mov    ah,3
	 int    14h
sendcmd3:
	ret
SENDCMD endp

;----------------------------------------------------------------
;
;	H a v e F o s s i l
;
;	Returns 1 if fossil found, else 0
;
	public	HaveFossil
HaveFossil	proc
	push	es
	push	bx
	mov	ax,3514h		; int 14h vector
	int	21h
	cmp	es:[bx+6],1954h		; FOSSIL magic number
	pop	bx
	pop	es
	jnz	nofoss
	mov	ax,1
	ret
nofoss:	xor	ax,ax
	ret

HaveFossil	endp

END start
