/*%.fh================================================================
;
;	Filename:	XC_NEWS.C			051 01-Apr-95
;
;	Author:		Ian Hall  ian@station.airtime.co.uk
;
;	Master Copy:	\usr\ian
;
;	References:	RFC 977
;
;	Copyright:	This program is copyright (C) 1995 by Ian Hall.
;			It may be freely distributed or modified
;			(provided such modifications are marked as
;			not being mine) for any non-commercial purpose.
;
;	Build:		Uses Borland C v3.1 *Large model*. Requires
;			XC_IO.ASM, and WILDMAT.C written by Rich Saltz
;			(rs@missor.TMC.COM in 1986)
;
;	Description:	XC_NEWS.EXE is a network news client program,
;			for DOS inspired by X_NEWS.BAS from Karl-Heinz Weiss
;			(khweis@mvmpc9.ciw.uni-karlsruhe.de) as used
;			in the SLIP_IT! suite of programs.
;
;			Note: XC_NEWS requires the TCP/IP, scripting
;			and packet-driver support provided by SLIP_IT!
;			and will not run stand-alone.
;
;	Revision History:
;	000	09-Feb-95  IH	Original
;	001	01-Mar-95  IH	Radical overhaul to use XOVER & kill files
;v1.0	002	15-Mar-95  IH	%killlinesover and %killbytesover etc
;	003	24-Mar-95  IH	%L and %B in killfile; no argv in AddArtList()
;				Extra ferror() checking in get_article()
;				check_break(); stimeout = 60, not 10 (!)
;				cmd_stack max is 8
;	004	25-Mar-95  IH	rnews length bug fix
;	005	01-Apr-95  IH	yarn_exn(), next_news() removed - simplified posting
;
*%.end==============================================================*/

//#define USE_FOSSIL
//#define DEBUG
//#define NEWSTACK

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <time.h>

#define SIGNON	"*** Xc_news  v1.1  April 95 ***\n\n"

typedef	unsigned short	ushort;

#define BYTESFIELD	6
#define LINESFIELD	7

#define ESC		27
#define CR		13
#define MAXFILEPATH	100

#ifdef NEWSTACK
	char	stack[8192];			/* 8k stack */
	ushort	saveSS;
	ushort	saveSP;
	ushort	saveBP;
#endif // NEWSTACK

//	char	copybuf[8192];
	char	inbuf[1024];
	char	outbuf[1024];
	struct	find_t	ffblk;
	char	starttime[32];

	char	*cfgfile = "x_tcp.cfg";

	char	newsrc[MAXFILEPATH] = "x_news.rc";
//	char	d_in[MAXFILEPATH] = "d-????.in";
//	char	d_out[MAXFILEPATH] = "d-????.out";
	char	n_msg[] = "spool\\n????.msg";
	char	getfile[MAXFILEPATH] = "get";
//	char	yarn_news[MAXFILEPATH];
	char	infile[MAXFILEPATH];
//	char	slipfile[MAXFILEPATH];
	char	logfile[MAXFILEPATH] = "debug.log";
	char	newgroupsfile[MAXFILEPATH] = "newgrps";
	char	histfile[MAXFILEPATH] = "history";
//	char	overfile[MAXFILEPATH] = "overview";
	char	abuf[1026];
	char	breakStat = 0;
	FILE	*fdLog;
	FILE	*fdHist;
        char	abname[100];
        char	art_extra[100];

	long	gr_anr, gr_num, gr_first, gr_last;
	time_t	tstart, t1;
	long	bytecount = 0;
	time_t	time_max;
	int	new_max;
	int	msg_max;
	int	cmd_stack;
	int	dele;
//	int	articlecount = 0;
	int	ArticleTotal = 0;
	int	port;				/* for use with FOSSIL */
	int	stimeout = 60;			/* timeout in seconds */
	int	ttimeout;			/* timeout in ticks */

	struct artlist {
		long	artnum;
		long	bytes;
		int	flag;
		struct	artlist	*next;
	} *artliststart, *artlistend;

	int	artlistcount;

	struct killlist {
		char	*killpattern;
		struct	killlist *next;
	} *killstart, *killend;

	int	killcount;
	int	killignorecase = 0;

	int	dokillbytesover = 0;
	int	dokilllinesover = 0;
	long	killbytesover = 0;
	long	killlinesover = 0;
	long	artLines;
	long	artBytes;

	extern	int	wildmat(char *buf, char *pat, char *argv[]);
	extern	int	HaveFossil(void);	/* for use with FOSSIL */

/****************************************************************/

#ifdef DEBUG

//	int	LPrintf(char *fmt, ...);

int HaveFossil(void)
{
	return 1;
}

int RCVCMD(char *cmd, ushort size)
{
	char	line[100];
	char	*p;

	printf("RCVCMD: ");
	gets(line);
	if(line[0] == '\0') strcpy(line,".");
	else strcat(line,"\n");
	p = line;
	do {
		*cmd++ = *p;
	} while(*p++);
	return strlen(line);
}

int RCVMSG(char *cmd, ushort size)
{
	char	line[100];
	char	*p;
	int	len;

	printf("RCVMSG: ");
	gets(line);
	if(line[0] == '\0') strcpy(line,".");
	else strcat(line,"\n");
	p = line;
	do {
		*cmd++ = *p;
	} while(*p++);
	len =  strlen(line);
	if(len == 1) len = -1;
	return len;
}

int RCVCHR(void)
{
//	int	c;
//
//	printf("RCVCHR: ");
//	c = getche();
//	if(c == 3) exit(0);
//	return c;
	return -1;
}

int SENDCMD(char *cmd, ushort size)
{
	char	line[100];

//	cmd = (char far *)(((long)seg << 16) + off);
	printf("SENDCMD: %Fs",cmd);
//	printf("SENDCMD return status? ");
//	gets(line);
//	return atoi(line);
	return 1;
}

#else
	extern	int	RCVCMD(char *cmd, ushort size);
	extern	int	RCVMSG(char *cmd, ushort size);
	extern	int	RCVCHR(void);
	extern	int	RFLUSH(void);
	extern	int	SENDCMD(char *cmd, ushort size);
#endif


/****************************************************************
*
*	L P r i n t f
*
*	Output to stdio, and to a log file if enabled
*/
int LPrintf(char *fmt, ...)
{
	int	st;
	va_list	argptr;

	va_start(argptr,fmt);
	st = vprintf(fmt,argptr);
	if(fdLog) st = vfprintf(fdLog,fmt,argptr);
	va_end(argptr);
	return st;
}


/****************************************************************
*
*	L o g I n i t
*/
void LogInit(void)
{
	if(logfile[0]) {
		fdLog = fopen(logfile,"a");
		if(!fdLog) fdLog = fopen(logfile,"w");
		if(fdLog) {
			fprintf(fdLog,"----------------------------------------------------------------\n");
		}
	} else {
		fdLog = 0;
	}
}


/****************************************************************
*
*	H i s t I n i t
*/
void HistInit(void)
{
	fdHist = fopen(histfile,"r+");
	if(!fdHist) fdHist = fopen(histfile,"w");
	if(!fdHist) {
		LPrintf("!Error could not open history file '%s'\n",histfile);
	}
}


/****************************************************************
*
*	L o g E n d
*/
void LogEnd(void)
{
	if(fdLog) {
		fclose(fdLog);
	}
	if(fdHist) {
		fclose(fdHist);
	}
}


/****************************************************************
*
*	L T r i m
*
*	Copy and trim off leading whitespace from a string
*/
char *LTrim(char *new, char *old)
{
	char	c;

	while(c = *old++)
		if(!isspace(c)) break;
	old--;
	strcpy(new,old);
	return new;
}


/****************************************************************
*
*	R T r i m
*
*	Copy and trim off trailing whitespace from a string
*/
char *RTrim(char *new, char *old)
{
	char	*p;
	char	*last;
	char	c;
	int	len;


	p = old;
	last = old;		/* point to last nonwhitespace */
	while(c = *p++)
		if(!isspace(c)) last = p;    		/* or just after */
	len = last - old;
	if(len) strncpy(new,old,len);
	new[len] = '\0';

	return new;
}


/****************************************************************
*
*	S k i p W E C
*
*	Skip past Whitespace, Equals-signs, and Colons
*/
char *SkipWEC(char *p)
{
	char	c;

	while(c = *p++) {
		if(isspace(c)) continue;
		if(c == '=') continue;
		if(c == ':') continue;
		break;
	}
	return --p;
}


/****************************************************************
*
*	M a t c h P a r m
*
*/
char *MatchParm(char *label, char *test)
{
	int	len;

	len = strlen(label);
	if(!strnicmp(label,test,len)) {		/* does it match? */
		test = SkipWEC(test + len);	/* point to parameter */
		return test;
	}
	return NULL;				/* no match */
}


/****************************************************************
*
*	S t r S e t
*
*/
int StrSet(char *label, char *test, char *dest)
{
	char	*p;

	if((test = MatchParm(label,test)) != 0) {
		strcpy(dest,test);
		if(p = strchr(dest,'#')) *p = 0;	/* lop off comments */
//		p = dest + strlen(dest) - 1;
//		while((p > dest) && (*p == ' ')) *p = 0;	/* right trim */
		LTrim(dest,RTrim(dest,dest));		/* short back & sides */
		return 1;
	}
	return 0;
}



/****************************************************************
*
*	s e n d _ c m d
*/
int send_cmd(char *cmd)
{
	int	st;

	strcpy(outbuf,cmd);
	strcat(outbuf,"\n");
//	LPrintf("send_cmd:%s",outbuf);	/* DEBUG */
	st = SENDCMD(outbuf,strlen(outbuf));
//	LPrintf("send_cmd:0x%04x\n");	/* DEBUG */
	if(st < -8192) {
		LPrintf("!Error: timeout in send_cmd: 0x%04x\n",st);
	}
	return st;
}


/****************************************************************
*
*	g e t _ c m d
*/
int get_cmd(char *p)
{
	int	st;

	p[0] = '\0';
	st = RCVCMD(inbuf,sizeof(inbuf));
	if(st > 0) {
		if(st > sizeof(inbuf)) st = sizeof(inbuf);    /* sanity check */
		strncpy(p,inbuf,st);
		p[st] = '\0';
//		LPrintf("get_cmd:0x%04x:%s\n",st,p);	/* DEBUG */
	} else if(st < -8192) {
		LPrintf("!Error: timeout in get_cmd: 0x%04x\n",st);
//	} else {
//		LPrintf("get_cmd:0x%04x\n",st);	/* DEBUG */
	}
//	fflush(fdLog);	/* DEBUG */
	return st;
}


/****************************************************************
*
*	S t r M e s s a g e I D
*
*	Extract a <message-id> from src into id
*/
int StrMessageID(char *id, char *src, int maxlen)
{
	char	*p, *q;
	int	len = 0;

	if(p = strchr(src,'<')) {
		if(q = strchr(p,'>')) {
			q++;
			len = q - p;
			if(len > maxlen) len = maxlen;
			strncpy(id,p,len);
		}
	}
	id[len] = '\0';
	return len;
}


/****************************************************************
*
*	A d d A r t L i s t
*
*	Check Message-ID embedded in XOVER line in buf against
*	current kill-file, then against history file, and add
*	article number to linked list if to be fetched.
*
*	003	24-Mar-95  IH	%L and %B in killfile, no argv in AddArtList()
*/
void AddArtList(char *buf)
{
	int	want = 1;
	int	keep;
	int	i;
        int	len;
	char	messid[100];
	char	line[100];
	char	*p, *q, *r;
	struct	artlist	*pa;
	struct	killlist	*pk;
	long	anr;
//	char	*argv[32];

	anr = atol(buf);
	if(anr <= 0) {				/* sanity check */
		LPrintf("!Error can't get article number from XOVER list\n");
		return;
	}

	if(dokillbytesover || dokilllinesover) want = 0;

	if(killcount) {
		pk = killstart;
		while(pk) {
			p = pk->killpattern;
//			printf("killpattern: '%s'\n",p);//DEBUG
//			memset(argv,0,32 * sizeof(char *));
			keep = 0;
			if(*p == '!') {
				p++;
				keep = 1;
			}
			if(*p == '%') {			/* [003] */
				p++;
				if(*p == 'L') {
//					LPrintf("artLines=%ld, L=%ld\n",artLines,atol(p + 1));//DEBUG
					if(artLines > atol(p + 1)) {
						want = keep;
					}
				} else if(*p == 'B') {
					if(artBytes > atol(p + 1)) {
						want = keep;
					}
				}
			}

			/* don't pattern-match if it won't change anything: */

//			if((want != keep) && wildmat(buf,p,argv)) {
			if((want != keep) && wildmat(buf,p,(char **)0)) {
				want = keep;

//				for(i = 0; argv[i]; i++) {
////					printf(" argv: '%s'\n",argv[i]);//DEBUG
//					free(argv[i]);
//				}
//			} else {
//				printf(" no match\n");//DEBUG

			}
			pk = pk->next;
		}
	}

	if(want && fdHist) {
		len = 0;
		p = buf;
		while(p = strchr(p,'\t')) {
			if(*++p == '<') {
				len = StrMessageID(messid,p,sizeof(messid));
				break;
			}
		}
		if(len) {
			rewind(fdHist);
			while(fgets(line,sizeof(line),fdHist)) {
				if(!strncmp(messid,line,len)) {
					LPrintf("News duplicate: %s\n",messid);
					want = 0;		/* discard duplicates */
					break;
				}
			}
		}
	}

	if(!want) return;		/* unless headers wanted */

	pa = (struct artlist *)malloc(sizeof(struct artlist));
	if(pa) {
//		printf("pa=0x%08lx anr=%ld\n",pa,anr);//DEBUG
		pa->artnum = anr;
		pa->bytes = artBytes;
		pa->flag = 0;		/* for now */
		pa->next = 0;
		if(artlistend) artlistend->next = pa;
		else artliststart = pa;
		artlistend = pa;
		artlistcount++;
	} else {
		LPrintf("!Error could not allocate memory\n");
	}
}

/****************************************************************
*
*	R e l e a s e A r t L i s t
*
*	Free all memory allocated for an article list
*/
void ReleaseArtList(void)
{
	struct	artlist	*pa;

	while(artliststart) {
		pa = artliststart->next;
		free(artliststart);
		artliststart = pa;
	}
	artlistend = 0;
	artlistcount = 0;
}

/****************************************************************
*
*	R e l e a s e K i l l L i s t
*
*	Free all memory allocated for a kill file list
*/
void ReleaseKillList(void)
{
	struct	killlist *pk;

	while(killstart) {
		pk = killstart->next;
		free(killstart->killpattern);
		free(killstart);
		killstart = pk;
	}
	killend = 0;
	killcount = 0;
}



/****************************************************************
*
*	e x e c u t e _ c m d
*
*	Syntax: $command item... > resultfile
*/
void execute_cmd(char *cmd)
{
	FILE	*fd;
	long	sum;
	int	len;
	int	st;
	char	*p;
	char	resultfile[MAXFILEPATH];
	char	nntpCommand[100];

	cmd++;					/* skip over '$' */
	nntpCommand[0] = '\0';
	sscanf(cmd,"%s",nntpCommand);
	if(nntpCommand == '\0') return;

	resultfile[0] = '\0';
	p = strchr(cmd,'>');
/* Need to check for " >" to avoid conflict with (say) ARTICLE <Message-ID> */
	if(p && isspace(*(p - 1))) {
		sscanf(p + 1,"%s",resultfile);
	}
	if(resultfile[0] == '\0') strcpy(resultfile,"x_news.rsp");

	LPrintf("Executing command: '%s'\n",nntpCommand);
	send_cmd(nntpCommand);
	get_cmd(abuf);
	LPrintf("%s\n",abuf);
	st = atoi(abuf);

	switch(st) {
	case 100:
	case 215:
	case 220:
	case 221:
	case 222:
	case 230:
	case 231:
		LPrintf("Writing to: '%s'\n",resultfile);
		fd = fopen(resultfile,"wb");
		if(!fd) {
			LPrintf("!Error creating '%s'\n",resultfile);
			break;
		}
		sum = 0;
		do {
			st = RCVMSG(inbuf,sizeof(inbuf));
			if(st < -8192) {
				LPrintf("!Error: timeout in execute_cmd: 0x%04x\n",st);
				break;
			}
			len = st;
			if(len < 0) {
				len = -len - 2;		/* lop off ".\n" */
				if(len <= 0) break;
			}
			if(len >= sizeof(inbuf)) len = sizeof(inbuf) - 1;
//			inbuf[len] = '\0';
//			fputs(inbuf,fd);
			fwrite(inbuf,1,len,fd);
			sum += len;
			printf("%ld\r",sum);
		} while(st > 0);
		fclose(fd);
		break;

	default:
		break;
	}
}


/****************************************************************
*
*	a b b r e v i a t e _ g r o u p _ n a m e
*/
char *abbreviate_group_name(char *abbr, char *group)
{
	int	newfield = 1;
	char	c;
	char	*abbr0 = abbr;

	while(c = *group++) {
		if(newfield) {
			*abbr++ = c;		/* first letter of new field */
			newfield = 0;
		} else if(c == '.') {
			newfield = 1;
		} else if((c == '-') || (c == '_')) {
			*abbr++ = c;		/* keep dashes & underscores */
			newfield = 1;
		}
	}
	*abbr = '\0';
	return abbr0;
}


/****************************************************************
*
*	g e t _ a r t i c l e
*
*	Note: fseek() does not work for files opened for append,
*	hence the clunky "r+b" then "w+b".
*/
int get_article(char *savefile, long expected, int rnews)
{
	FILE	*fd;
	time_t	tart;
	long	tdifArt;
	long	tdifTot;
	long	sum;
	long	s0;
        int	i;
	int	len;
	int	ntabs;
	int	rcvstat;
	int	filestat;
	char	hdr[20];
	char	*p1, *p2;

	fd = fopen(savefile,"r+b");		/* modify existing */
	if(!fd) fd = fopen(savefile,"w+b");	/* else create */
	if(!fd) {
		LPrintf("!Error in get_article opening '%s'\n",savefile);
		return 0;
	}

	if(expected) printf("          Expected: %ld\r",expected);

	fseek(fd,0L,SEEK_END);			/* append */
	s0 = ftell(fd);				/* remember start of header */

	if(rnews) {
		for(len = 0; len < 20; len++) hdr[len] = ' ';
		fwrite(hdr,1,20,fd);		/* 20-byte rnews header */
	}

	tart = time(NULL);

	sum = 0;

	if(rnews == 2) {			/* overview as kill template */
		fputs(abuf,fd);			/* pseudo-header is in abuf */
		ReleaseArtList();		/* new list will be built */

		while(1) {
			/* read lines, not chunks */
			rcvstat = RCVCMD(inbuf,sizeof(inbuf));
			if(rcvstat < 0) {
				LPrintf("!Error: timeout in get_article: 0x%04x\n",len);
				break;
			}
			len = rcvstat;
			if((len == 1) && (inbuf[0] == '.')) break;	/* end */
			if(len >= (sizeof(inbuf) - 3)) len = sizeof(inbuf) - 3;
			inbuf[len++] = '\n';
			inbuf[len++] = '\n';
			inbuf[len] = '\0';
//			AddArtList(inbuf);
			dokillbytesover = 0;
			dokilllinesover = 0;
			ntabs = 0;
			p1 = p2 = 0;
			for(i = 0; i < len; i++) {	/* process/split long XOVER lines */
			    if(inbuf[i] == '\t') {
				ntabs++;
				if(ntabs == 2) {
				    p1 = &inbuf[i];
				} else if(ntabs == 4) {
				    p2 = &inbuf[i];
//				    if(!killbytesover && !killlinesover) break;
//				} else if((ntabs == BYTESFIELD) && killbytesover) {
				} else if(ntabs == BYTESFIELD) {
//				    if(atol(&inbuf[i + 1]) > killbytesover) {
//					dokillbytesover = 1;
//					if(!killlinesover) break;
//				    }
				    artBytes = atol(&inbuf[i + 1]);
//				} else if((ntabs == LINESFIELD) && killlinesover) {
				} else if(ntabs == LINESFIELD) {
//				    if(atol(&inbuf[i + 1]) > killlinesover) {
//					dokilllinesover = 1;
//				    }
				    artLines = atol(&inbuf[i + 1]);
				    break;
				}
			    }
			}
			if(killlinesover && (artLines > killlinesover))
				dokilllinesover = 1;
			if(killbytesover && (artBytes > killbytesover))
				dokillbytesover = 1;
			AddArtList(inbuf);
			if(p1) *p1 = '\n';
			if(p2) *p2 = '\n';
			fwrite(inbuf,1,len,fd);
			fflush(fd);
			if(ferror(fd)) {
				LPrintf("!Error in get_article writing to '%s'\n",savefile);
				break;
			}
			sum += len;
			printf("%ld\r",sum);
		}

	} else {

		do {
			rcvstat = RCVMSG(inbuf,sizeof(inbuf));
			if(rcvstat < -8192) {
				LPrintf("!Error: timeout in get_article: 0x%04x\n",rcvstat);
				break;
			}
			len = rcvstat;
			if(len < 0) {
				len = -len - 2;		/* lop off ".\n" */
				if(len <= 0) break;
			}
			if(len >= sizeof(inbuf)) len = sizeof(inbuf);
			fwrite(inbuf,1,len,fd);
			if(ferror(fd)) {
				LPrintf("!Error in get_article writing to '%s'\n",savefile);
				break;
			}
			sum += len;
			printf("%ld\r",sum);
		} while(rcvstat > 0);
	}

	bytecount += sum;
//	articlecount--;
	ArticleTotal++;

	if(rnews) {
		fflush(fd);
//		sprintf(hdr,"#! rnews %010ld\n",sum);
		sprintf(hdr,"#! rnews %010ld\n",ftell(fd) - s0 - 20);	/* allow for 20-byte header [004] */
		fseek(fd,s0,SEEK_SET);
		fwrite(hdr,1,20,fd);
		fseek(fd,0L,SEEK_END);
	}

	filestat = ferror(fd);
	fclose(fd);

	t1 = time(NULL);
	tdifTot = t1 - tstart;
	tdifArt = t1 - tart;
	if(tdifArt <= 0) tdifArt = 1;
	if(tdifTot > 0) {
//		LPrintf("Art.:%d Bytes:%ld Time:%ld (%ld/sec:%ld/sec)\n",
//			ArticleTotal,bytecount,tdifTot,
//			(bytecount/tdifTot),(sum/tdifArt));
		LPrintf("Art.:%d %s Bytes:%ld (%ld/sec) Total:%ld Time:%d:%02d\n",
			ArticleTotal,art_extra,sum,(sum/tdifArt),bytecount,
			(int)(tdifTot/60),(int)(tdifTot%60));
	}

	if(rcvstat < -8192) return 0;

	if(filestat) {
		LPrintf("!Error: %d problem writing data to '%s'\n",
			savefile,savefile);
		return 0;
	}

	return 1;
}



/****************************************************************
*
*	g e t _ o v e r v i e w
*/
int get_overview(char *filename, char *group, long anr, int rtype)
{
	int	stat;

	if(!group[0]) {
		LPrintf("!Error: no group for overview\n");
		return 0;
	}

	strcpy(abuf,"GROUP ");
	strcat(abuf,group);
	stat = send_cmd(abuf);
	if(stat < 0) {
		LPrintf("!Error send_cmd in get_overview: GROUP st=%d\n",stat);
		return 0;
	}

	stat = get_cmd(abuf);
	LPrintf("%s\n",abuf);			/* GROUP feedback */
	if(stat < 0) {
		LPrintf("!Error get_cmd in get_overview: GROUP st=%d\n",stat);
		return 0;
	}
	if(atoi(abuf) != 211) {
		return 0;			/* no such group */
	}

	gr_num = gr_first = gr_last = 0;
	sscanf(abuf,"211 %ld %ld %ld",&gr_num,&gr_first,&gr_last);
	if(anr < 0) anr = gr_last + anr;
	if(anr < gr_first) anr = gr_first;
	if(anr > gr_last) {
		LPrintf("!Warning: no new overview data\n");
		return 0;
	}

	gr_anr = anr;

	sprintf(abuf,"XOVER %ld-%ld",anr,gr_last);
	send_cmd(abuf);

	get_cmd(abuf);
	LPrintf("%s\n",abuf);			/* XOVER feedback */

	if(atoi(abuf) != 224) {
		return 0;
	}

	if(rtype == 2) {			/* pseudo-header */
		sprintf(abuf,"Newsgroups: %s\nFrom: NNTP\nSubject: %s - overview\nDate: %s\nMessage-ID: <xover-%ld>\n\n",
			group,group,starttime,time(NULL));
	}

	return get_article(filename,0,rtype);
}


/****************************************************************
*
*	a t o n
*/
int aton(char *a)
{
	return ((a[0] - '0') * 10) + a[1] - '0';
}

/****************************************************************
*
*	a t o l t i m e
*
*	This is a bodge of a function.
*/
time_t atoltime(char *adate, char *atime)
{
	struct	date	d;
	struct	time	t;

	d.da_year = aton(&adate[0]) + 1900;
	if(d.da_year < 1980) d.da_year += 100;	/* millennium correction ;) */
	d.da_mon = aton(&adate[2]);
	d.da_day = aton(&adate[4]);
	t.ti_hour = aton(&atime[0]);
	t.ti_min = aton(&atime[2]);
	t.ti_sec = aton(&atime[4]);

	return dostounix(&d,&t);	/* relative to 00:00:00 Jan 1 1970 */
}



/****************************************************************
*
*	s p e c i a l _ c m d
*/
int special_cmd(char *cmd)
{
	char	group[100];
	char	numstr[100];
	char	filename[100];
	char	*fptr;
	long	anr;
	int	stat;
	int	rtype;
	struct	killlist *pk;
        FILE	*fd;
        long	newgroupstime;
        struct	tm	*tblock;
        int	tyear;

	cmd++;			/* skip over the '%' prefix */
	if(!strnicmp(cmd,"overview",8)) {

/* Command has the form:
** %overview group [number] [output-filename]
*/
		group[0] = '\0';
		numstr[0] = '\0';
		filename[0] = '\0';
		sscanf(cmd + 8,"%s %s %s",group,numstr,filename);
		if(!group[0]) {
			LPrintf("!Error: no group for overview\n");
			return 0;
		}
		anr = atoi(numstr);
		if((anr == 0) && !isdigit(numstr[0]) && !filename[0]) {
			strcpy(filename,numstr);
		}
//		if(!filename[0]) strcpy(filename,overfile);
		if(!filename[0]) {
			fptr = infile;
			rtype = 2;	/* psuedo news article */
		} else {
			fptr = filename;
			rtype = 0;		/* no rnews prefix */
		}

		art_extra[0] = '\0';
		if(get_overview(fptr,group,anr,rtype) == 0) return 0;
		sprintf(cmd + 8," %s %ld %s",group,gr_last,filename);
		return 1;


	} else if(!strnicmp(cmd,"newgroups",9)) {

/* Command has the form:
** %newgroups date time [output-filename]
*/
		group[0] = '\0';	/* date stored in here */
		numstr[0] = '\0';	/* time stored in here */
		filename[0] = '\0';
		sscanf(cmd + 9,"%s %s %s",group,numstr,filename);
		rtype = 0;		/* save as file */
		fptr = newgroupsfile;
		if(!isdigit(group[0]) || !isdigit(numstr[0])) {
			/* invalid date/time parameter. use 1 day ago */
			newgroupstime = tstart - (24L * 60 * 60);
		} else {
			newgroupstime = atoltime(group,numstr) - (15 * 60);
			if(filename[0]) fptr = filename;
		}

		tblock = localtime(&newgroupstime);
		tyear = tblock->tm_year;	/* - 1900; */
		if(tyear > 99) tyear -= 100;	/* millennium correction ;) */
		sprintf(abuf,"NEWGROUPS %02d%02d%02d %02d%02d%02d",
			tyear,
			tblock->tm_mon + 1,
			tblock->tm_mday,
			tblock->tm_hour,
			tblock->tm_min,
			tblock->tm_sec);
		send_cmd(abuf);

		get_cmd(abuf);
		LPrintf("%s\n",abuf);		/* NEWGROUPS feedback */

		if(atoi(abuf) != 231) {
			return 0;
		}

		art_extra[0] = '\0';
		if(get_article(fptr,0,rtype) == 0) return 0;

		tblock = localtime(&tstart);
		tyear = tblock->tm_year;	/* - 1900; */
		if(tyear > 99) tyear -= 100;	/* millennium correction ;) */
		sprintf(cmd + 9," %02d%02d%02d %02d%02d%02d %s",
			tyear,
			tblock->tm_mon + 1,
			tblock->tm_mday,
			tblock->tm_hour,
			tblock->tm_min,
			tblock->tm_sec,
			fptr);
		return 1;

	} else if(!strnicmp(cmd,"killfile",8)) {
		sscanf(cmd + 8,"%s",filename);
		if((fd = fopen(filename,"r")) == NULL) {
			LPrintf("!Error could not open killfile '%s'\n",filename);
			return 0;
		}
		ReleaseKillList();	/* Free memory of previous kill list */
		while(fgets(abuf,sizeof(abuf),fd)) {
			RTrim(abuf,abuf);
			if((abuf[0] == '#') || (abuf[0] == '\0'))
				continue;
//			if(killignorecase)
//				strlwr(abuf);
			pk = (struct killlist *)malloc(sizeof(struct killlist));
			if(!pk) {
				LPrintf("!Error could not allocate memory\n");
				return 0;
			}
			pk->next = 0;
//			RTrim(abuf,abuf);
			pk->killpattern = (char *)malloc(strlen(abuf));
			if(!pk->killpattern) {
				LPrintf("!Error could not allocate memory\n");
				free(pk);
				return 0;
			}
			strcpy(pk->killpattern,abuf);
			if(killend)
				killend->next = pk;
			else
				killstart = pk;
			killend = pk;
			killcount++;
		}
		return 1;

	} else if(!strnicmp(cmd,"nokill",6)) {
		ReleaseKillList();
		return 1;

	} else if(!strnicmp(cmd,"killignorecase",14)) {
		killignorecase = 1;
		return 1;

	} else if(!strnicmp(cmd,"nokillignorecase",16)) {
		killignorecase = 0;
		return 1;

	} else if(!strnicmp(cmd,"killbytesover",13)) {
		killbytesover = atol(cmd + 13);
		if(killbytesover < 0) killbytesover = 0;
		return 1;

	} else if(!strnicmp(cmd,"nokillbytesover",15)) {
		killbytesover = 0;
		return 1;

	} else if(!strnicmp(cmd,"killlinesover",13)) {
		killlinesover = atol(cmd + 13);
		if(killlinesover < 0) killlinesover = 0;
		return 1;

	} else if(!strnicmp(cmd,"nokilllinesover",15)) {
		killlinesover = 0;
		return 1;

	} else if(*cmd == '#') {
		return 1;		/* echo without complaining */

	}

	LPrintf("!Error: unknown command '%s'\n",cmd - 1);
	return 0;
}



/****************************************************************
*
*	g e t _ c f g
*/
int get_cfg(char *label, char *param)
{
	FILE	*fd;
	int	found = 0;

	fd = fopen(cfgfile,"r");
	if(!fd) {
		LPrintf("!Error opening '%s'\n",cfgfile);
		return 0;
	}
	while(fgets(abuf,sizeof(abuf),fd)) {
		if(StrSet(label,abuf,param)) {
			found = 1;
			break;
		}
	}
	fclose(fd);
	return found;
}
			


/****************************************************************
*
*	g e t _ c f g _ v a l
*
*	Have to do it this way to have option of leaving val unchanged.
*/
void get_cfg_val(char *label, void *val, int size)
{
	char	param[100];

	if(get_cfg(label,param)) {
		if(size == sizeof(long)) {
			*(long *)val = atol(param);
		} else {
			*(int *)val = atoi(param);
		}
	}
}



/****************************************************************
*
*	g e t _ c f g _ l o n g
*/
void get_cfg_long(char *label, long *val)
{
	char	param[100];

	if(get_cfg(label,param)) {
		*val = atol(param);
	}
}



/****************************************************************
*
*	c h e c k _ b r e a k
*
*	Note: Selecting an arbitrary article number could conflict
*	with history.
*
*	003	24-Mar-95  IH	check_break()
*/
int check_break(struct artlist **ppa)
{
	int	c = 0;
	long	nart;
	char	line[80];

	while(kbhit()) c = getch();
	if(c != ESC) return 0;

	breakStat = 0;
	printf("Press: Q(uit news), S(kip group), or ENTER ");
	if((c = getch()) == 0) c = getch();
	printf("\n");
	switch(toupper(c)) {
	case 'S':
		breakStat = 'S';
		break;
	case ESC:
	case 'Q':
		breakStat = ESC;
		break;
	case CR:
		printf("Article number (+ve) or count (-ve): ");
		gets(line);
		nart = atol(line);
		if(nart == 0) break;
		if(nart < 0) nart = gr_last + nart;
		*ppa = artliststart;
		while(*ppa) {
			if(nart <= (*ppa)->artnum) break;	/* pick nearest unkilled */
			*ppa = (*ppa)->next;
		}
		break;
	default:
		break;
	}
	return breakStat;
}



/****************************************************************
*
*	n e x t _ f i l e
*/
void next_file(char *fnext, char *fname)
{
	static	int	nbr0 = 0;
	int	wild;
	int	width;
	int	nbr;
	int	st;
	char	*p1,*p2;

	fnext[0] = '\0';
	p1 = strchr(fname,'?');
	if(!p1) {
		LPrintf("--next_file: !p1\n",st);
		return;
	}
	wild = p1 - fname;		/* question-mark offset */

	st = _dos_findfirst(fname,_A_NORMAL,&ffblk);
	while(!st) {
		nbr = atoi(&ffblk.name[wild]);
		if(nbr > nbr0) nbr0 = nbr;
		st = _dos_findnext(&ffblk);
	}
	nbr0++;
	p2 = p1;
	while(*p2++ == '?');
        p2--;
	width = p2 - p1;
	sprintf(fnext,"%.*s%0*d%s",wild,fname,width,nbr0,p2);
}
	


/****************************************************************
*
*	g e t _ g r o u p
*/
void get_group(char *group)
{
	char	gr[100];
        char	messid[100];
	char	*p;
	long	anr;
	int	st;
	int	push;
	long	sum;
	struct	artlist	*pa;
	struct	artlist	*pa_lag;
	int	nread = 0;
	FILE	*fd;

	if(group[0] == '\0') return;

	strcpy(gr,group);
	anr = 0;
	if(p = strchr(gr,' ')) {
		*p++ = '\0';		/* truncate, point to remainder */
		anr = atol(p);		/* get argument */
	}
	if(anr == 0) anr = -new_max;

	next_file(infile,n_msg);	/* new file for each group */

	abbreviate_group_name(abname,gr);
	strcpy(art_extra,abname);

	if(!get_overview(infile,gr,anr,2)) return;

	anr = gr_anr;			/* initialise to sensible value */

	push = 0;
//	printf("artlistcount=%d, artliststart=%lx\n",artlistcount,artliststart);//DEBUG
	if(artlistcount) {
		pa = artliststart;
		pa_lag = pa;
		while(pa) {
			anr = pa->artnum;
			sprintf(abuf,"ARTICLE %ld",anr);
//			printf("<-%s\n",abuf);//DEBUG
			send_cmd(abuf);
			push++;
			pa = pa->next;
			if(push >= cmd_stack) break;
		}
		while(1) {
			get_cmd(abuf);
			LPrintf("%s\n",abuf);
			st = atoi(abuf);
			if(st == 220) {
				StrMessageID(messid,abuf,sizeof(messid));
				sprintf(art_extra,"(%s:%ld/%ld)",abname,pa_lag->artnum,gr_last);
				get_article(infile,pa_lag->bytes,1);
				nread++;
				if(fdHist && messid[0]) {
					fseek(fdHist,0L,SEEK_END);
					fprintf(fdHist,"%s\n",messid);
					fflush(fdHist);
//					printf("HIST: %s\n",messid);	//DEBUG
				}
			} else {
				LPrintf("!Error Bad response from ARTICLE\n");
			}
			push--;
			if(ArticleTotal > msg_max) {
				LPrintf("!Warning: more than msg_max (%d) articles\n",msg_max);
				break;
			}
			if((time(NULL) - tstart) > time_max) {
				LPrintf("!Warning: time exceeds time_max (%ld)\n",time_max);
				break;
			}

			if(pa) {
				anr = pa->artnum;
				sprintf(abuf,"ARTICLE %ld",anr);
				send_cmd(abuf);
				push++;
				pa = pa->next;
			} else {
				if(!push) break;
			}
			pa_lag = pa_lag->next;

//			if(kbhit()) {
//				breakStat = toupper(getch());
//				if((breakStat == ESC) || (breakStat == 'S')) break;
//			}
			if(check_break(&pa)) break;
		}

		/* discard responses */
		if(push) {
			LPrintf("Discarding %d articles...\n",push);
			while(push) {
				sum = 0;
				do {
					st = get_cmd(abuf);
					if(st < 0) break;
					sum += strlen(abuf);
					printf("%ld\r",sum);
				} while(strcmp(abuf,"."));
				if(st < 0) break;
				st = get_cmd(abuf);
				push--;
			}

		} else {
			anr = gr_last;
		}

	} else {
		LPrintf("!Warning: no articles will be fetched\n");
		anr = gr_last;
	}

/* Update active file for Yarn
*/
	if(p = strchr(infile,'.')) *p = '\0';		/* truncate for now */
	fd = fopen("spool\\active","a");
	if(!fd) fd = fopen("spool\\active","w");
	fprintf(fd,"%s\t%s\tun\n",&infile[6],gr);	/* messy */
	fclose(fd);
	if(p) *p = '.';					/* restore */

/* Update last article number in group line from X_NEWS.RC
*/
	if(anr > gr_last) anr = gr_last;
	p = group + strlen(gr);
	sprintf(p," %ld",anr);

	LPrintf("*** Done: %s *** %d articles written to: '%s' ***\n",gr,nread,infile);
}


/****************************************************************
*
*	g e t _ g e t f i l e
*
*	This routine looks for lines beginning with '<' or
*	with "Message ID:" in the file getfile, and fetches
*	the articles. Should cope with unprocessed headers
*	or bare IDs. The getfile itself is rewritten as a
*	log of fetched/missing articles, which may be used
*	again
*/
void get_getfile(void)
{
	FILE	*fin;
	FILE	*fout;
	char	line[100];
	char	*p, *q;
	char	tmpname[] = "GET.$$$";
	char	savname[] = "GET.BAK";
	int	st;
	int	kbstat = 0;

	fin = fopen(getfile,"r");
	if(fin == 0) {
		LPrintf("Skipping: no getfile '%s'\n",getfile);
		return;
	}

	next_file(infile,n_msg);		/* need somewhere... */

	fout = 0;				/* not ready */
	while(fgets(abuf,sizeof(abuf),fin)) {	/* some headers have long lines */
		if((abuf[0] == '<') || (!strnicmp(abuf,"Message-ID:",11))) {
			if(p = strchr(abuf,'<')) {
				if(q = strchr(p,'>')) {
					*(q + 1) = '\0';	/* isolate ID */
					if(!fout) {
					    fout = fopen(tmpname,"w");
					    if(fout == 0) {
						LPrintf("!Error creating '%s'\n",tmpname);
						fclose(fin);
						return;
					    }
					}
					if(kbhit()) {
						if(getch() == ESC) {
							kbstat = ESC;
						}
					}
					strncpy(line,p,sizeof(line));
					if(kbstat != ESC) {
						strcpy(abuf,"ARTICLE ");
						strcat(abuf,line);
						send_cmd(abuf);
						get_cmd(abuf);
						LPrintf("%s\n",abuf);
						st = atoi(abuf);
						if(st == 220) {
							art_extra[0] = '\0';
							get_article(infile,0,1);
							fputs("#Got: ",fout);
						}
					} else {
						LPrintf("Skipping: %s\n",line);
					}
					fputs(line,fout);
					fputc('\n',fout);
				}
			}
		}
	}
	fclose(fin);
	if(fout) {
		fclose(fout);
		unlink(savname);
		rename(getfile,savname);
		rename(tmpname,getfile);
	} else {
		LPrintf("!Warning: No articles to fetch in getfile '%s'\n",getfile);
	}
}


/****************************************************************
*
*	g e t _ n e w s
*/
void get_news(void)
{
	FILE	*fin;
	FILE	*fout;
	char	line[100];
	char	tmpname[] = "X_NEWS.$$$";
	char	savname[] = "X_NEWS.BAK";

//	if(breakStat == 'S') {
//		LPrintf("--get_news: breakStat='S'\n");
//		return;
//	}

	fin = fopen(newsrc,"r");
	if(fin == 0) {
		LPrintf("!Error opening '%s'\n",newsrc);
		return;
	}
	fout = fopen(tmpname,"w");
	if(fout == 0) {
		LPrintf("!Error creating '%s'\n",tmpname);
		fclose(fin);
		return;
	}
	while((breakStat != ESC) && fgets(line,sizeof(line),fin)) {
		LTrim(line,RTrim(line,line));
		switch(line[0]) {
		case '#':
		case '\0':
//			LPrintf("%s\n",line);
			break;
		case '$':
			execute_cmd(line);
			fputc('#',fout);	/* comment-out command */
			break;
		case '%':
			LPrintf("%s\n",line);
			special_cmd(line);
			break;
		default:
			LPrintf("Newsgroup: %s\n",line);
			get_group(line);
			break;
		}
		fprintf(fout,"%s\n",line);
	}
	while(fgets(line,sizeof(line),fin)) {
		fprintf(fout,"%s",line);
	}
	fclose(fin);
	fclose(fout);
	unlink(savname);
	rename(newsrc,savname);
	rename(tmpname,newsrc);
}



/****************************************************************
*
*	r e a d _ l n
*/
char *read_ln(FILE *fd, int *lng)
{
	fgets(abuf,sizeof(abuf),fd);
	*lng = strlen(abuf) - 1;
	abuf[*lng] = '\0';
	return abuf;
}


#ifdef NOTWANTED
/****************************************************************
*
*	n e x t _ n e w s
*/
char *next_news(char *ffound, char *fname)
{
	static	int	first;
	int	st;
	FILE	*fd;
	char	*rl;
	int	lng;

	ffound[0] = '\0';
	if(first == 0) {
		st = _dos_findfirst(fname,_A_NORMAL,&ffblk);
	} else {
		st = _dos_findnext(&ffblk);
		first = 1;
	}

	while(!st) {
		fd = fopen(ffblk.name,"rb");
		rl = read_ln(fd,&lng);
		fclose(fd);
		if(!strncmp(rl,"#!",2)) break;
		st = _dos_findnext(&ffblk);
	}
	if(!st) strcpy(ffound,ffblk.name);

	return ffound;
}
#endif	


/****************************************************************
*
*	p o s t _ n e w s
*/
int post_news(char *outfile)
{
	FILE	*fd;
	int	post_stat = 200;
	int	st;
	int	count;
	long	ptr;
	long	nPtr;
	int	lng;
	int	len;
	char	*ap,*topic,*p;
	char	abuf[100];

	fd = fopen(outfile,"rb");
	while(!feof(fd)) {
		ptr = 0;
		ap = read_ln(fd,&lng);
		if(strncmp(ap,"#!",2)) break;
		count = 0;
		nPtr = atol(ap + 9);
		st = send_cmd("POST");
		st = get_cmd(abuf);
		if(abuf[0] == '3') {
			do {
				ap = read_ln(fd,&lng);
				ptr += lng;
				LPrintf("Sent: %ld/%ld\r",ptr,nPtr);
				LTrim(ap,(RTrim(ap,ap)));
				topic = ap;
				p = strchr(ap,':');
				if(p) len = p - ap;
				else if(topic[0] == '<') {
					p = topic;
					len = strlen(topic);
				}
				if(!strncmp("SUBJECT",topic,len) ||
				    !strncmp("FROM",topic,len) ||
				    !strncmp("NEWSGROUPS",topic,len) ||
				    !strncmp("REFERENCES",topic,len) ) {
					st = send_cmd(ap);
				}
			} while(p);
			send_cmd(ap);
			while(ptr < nPtr) {
				ap = read_ln(fd,&lng);
				ptr += lng;
				LPrintf("Sent: %ld/%ld ...\r",ptr,nPtr);
				if(!strcmp(ap,".")) ap = "..";
				send_cmd(ap);
			}
			send_cmd(".");
			get_cmd(abuf);
			LPrintf("%s\n",abuf);
			post_stat = atoi(abuf);
			if(abuf[0] != '2') {
				fclose(fd);
				return post_stat;
			}
		} else {
			LPrintf("%s\n",abuf);		/* bad POST feedback */
			fclose(fd);
			return atoi(abuf);
		}
	}
	fclose(fd);
//	post_stat = 0;
	if(!dele) {
		LPrintf("Deleting: %s\n",outfile);
		unlink(outfile);
	}
	return post_stat;
}


/****************************************************************
*
*	q u i t _ n e w s
*/
void quit_news(void)
{
	int	c;
        int	i = 0;

	LogEnd();

	LPrintf("Quitting NNTP...\n");
	send_cmd("QUIT");

#ifdef	USE_FOSSIL
	RFLUSH();
#else
	do {
		c = RCVCHR();
		printf("%d\r",i);
		if(c == -1) i++;
		if(kbhit()) {
			getch();
			break;
		}
	} while((c >= -1) && (i < 5000));
#endif
//	LogEnd();
}


#ifdef NOTWANTED
/****************************************************************
*
*	y a r n _ e x n
*/
void yarn_exn(char *yarnfile, char *slipfile)
{
	FILE	*fin;
	FILE	*fout;
	int	i;
	long	lofmsg;
	char	lof[4];

	fin = fopen(yarnfile,"rb");
	if(!fin) {
		LPrintf("!Error opening '%s'\n",yarnfile);
		return;
	}

	fout = fopen(slipfile,"wb");
	if(!fout) {
		LPrintf("!Error creating '%s'\n",slipfile);
		return;
	}

	do {
		fread(lof,1,4,fin);
		if(feof(fin)) break;
		lofmsg = 0;
		for(i = 0; i < 4; i++) {
			lofmsg = (256 * lofmsg) + lof[i];
		}
		sprintf(abuf,"#! rnews %ld\n",lofmsg);
		fwrite(abuf,1,strlen(abuf),fout);
		while(lofmsg >= sizeof(copybuf)) {
			fread(copybuf,1,sizeof(copybuf),fin);
			fwrite(copybuf,1,sizeof(copybuf),fout);
			lofmsg -= sizeof(copybuf);
		}
		if(lofmsg) {
			fread(copybuf,1,lofmsg,fin);
			fwrite(copybuf,1,lofmsg,fout);
		}
	} while(!feof(fin));

	fclose(fin);
	fclose(fout);
}
#endif


/****************************************************************
*
*	m a i n
*/
main(argc,argv)
int argc;
char *argv[];
{
	int	st;
	int	i;
	struct	tm	*tblock;
	char	nname[100];

/* New stack: must be inline
*/
#ifdef NEWSTACK
	saveSS = _SS;
	saveSP = _SP;
	saveBP = _BP;
	_SS = FP_SEG(stack);
	_SP = (FP_OFF(&stack[sizeof(stack) - 2])) & 0xFFFE;
	_BP = _SP - 4;
#endif // NEWSTACK

	tstart = time(NULL);
	tblock = localtime(&tstart);
	strcpy(starttime,asctime(tblock));
	RTrim(starttime,starttime);

	get_cfg("logfile",logfile);		/* need this way up here */
	LogInit();

	LPrintf(SIGNON);
	LPrintf("Started: %s\n",starttime);

	get_cfg_val("timeout",&stimeout,sizeof(stimeout));
	ttimeout = (((long)stimeout) * 1000) / 55;	/* seconds -> ticks */

#ifdef USE_FOSSIL
	if(!HaveFossil()) {
		LPrintf("!Error no FOSSIL found\n");
#ifdef NEWSTACK
		_SS = saveSS;		/* resore old stack - inline */
		_SP = saveSP;
		_BP = saveBP;
#endif // NEWSTACK
		exit(-1);
	}
	st = 200;
	port = 0;	/* TEMP */
	send_cmd("\005\n\005\n\005\n");	/* turn off echo */
	RFLUSH();
#else
	get_cmd(abuf);			/* signon message from server */
//	get_cmd_init(abuf);		/* signon message from server */
	LPrintf("%s\n",abuf);
	st = atoi(abuf);

	if((st != 200) && (st != 201)) {
		quit_news();
#ifdef NEWSTACK
		_SS = saveSS;		/* resore old stack - inline */
		_SP = saveSP;
		_BP = saveBP;
#endif // NEWSTACK
		exit(-1);		/* get tcpport to try again? */
	}
#endif


//	if(argc > 1) cfgfile = argv[1];
	for(i = 1; i < argc; i++) {
		if(!strnicmp(argv[i],"-p",2)) {
			port = argv[i][2] - '0';
		} else {
			cfgfile = argv[i];
		}
	}
#ifdef USE_FOSSIL
	LPrintf("Port = %d\n",port);
#endif

	get_cfg("newsrc",newsrc);
//	get_cfg("infile",d_in);
//	get_cfg("outfile",d_out);
//	get_cfg("yarn_news",yarn_news);
	get_cfg("getfile",getfile);
//	get_cfg("overfile",overfile);
	get_cfg("newgroupsfile",newgroupsfile);
	get_cfg("historyfile",histfile);
	HistInit();

	get_cfg_val("t_max",&time_max,sizeof(time_max));
	get_cfg_val("new_max",&new_max,sizeof(new_max));
	get_cfg_val("msg_max",&msg_max,sizeof(msg_max));
	get_cfg_val("cmd_stack",&cmd_stack,sizeof(cmd_stack));
	get_cfg_val("keepbuf",&dele,sizeof(dele));

	if(cmd_stack == 0) cmd_stack = 4;
	else if(cmd_stack > 8) cmd_stack = 8;
	if(time_max == 0) time_max = 7200;	/* 2 hours should be enough */
	if(new_max == 0) new_max = 100;
	if(msg_max == 0) msg_max = 5000;

//	next_file(infile,d_in);


/* Look for articles to be posted */
//	if(yarn_news[0]) {
//		next_file(slipfile,d_out);
//		yarn_exn(yarn_news,slipfile);
//	}
//
//	while(st == 200) {
//		next_news(nname,d_out);
//		if(!nname[0]) break;
//		LPrintf("%s\n",nname);
//		st = post_news(nname);
//	}


/* Start posting if allowed to post:
*/
	if(st == 200) {
		st = _dos_findfirst("spool\\n????.out",_A_NORMAL,&ffblk);
		while(st == 0) {
			strcpy(nname,"spool\\");
			strcat(nname,ffblk.name);
			LPrintf("Posting '%s'\n",nname);
			st = post_news(nname);
			if(st == 0) {
				if(dele == 0) {
					LPrintf("Deleting '%s'\n",nname);
					unlink(nname);
				}
			}
			st = _dos_findnext(&ffblk);
		}
	}

	get_getfile();

	get_news();

	quit_news();

	ReleaseArtList();
	ReleaseKillList();

#ifdef NEWSTACK
	_SS = saveSS;		/* resore old stack - inline */
	_SP = saveSP;
	_BP = saveBP;
#endif // NEWSTACK
	exit(0);
}
